Index: src/backend/commands/cluster.c
===================================================================
RCS file: /home/alvherre/Code/cvs/pgsql/src/backend/commands/cluster.c,v
retrieving revision 1.162
diff -c -p -r1.162 cluster.c
*** src/backend/commands/cluster.c	19 May 2007 01:02:34 -0000	1.162
--- src/backend/commands/cluster.c	29 Aug 2007 22:07:04 -0000
*************** cluster_rel(RelToCluster *rvtc, bool rec
*** 276,281 ****
--- 276,287 ----
  		}
  
  		/*
+ 		 * Note: we don't need to check whether the table is a temp for a
+ 		 * remote session here, because it will be checked in
+ 		 * check_index_is_clusterable, below.
+ 		 */
+ 
+ 		/*
  		 * Check that the index still exists
  		 */
  		if (!SearchSysCacheExists(RELOID,
*************** swap_relation_files(Oid r1, Oid r2, Tran
*** 995,1004 ****
  }
  
  /*
!  * Get a list of tables that the current user owns and
!  * have indisclustered set.  Return the list in a List * of rvsToCluster
!  * with the tableOid and the indexOid on which the table is already
!  * clustered.
   */
  static List *
  get_tables_to_cluster(MemoryContext cluster_context)
--- 1001,1037 ----
  }
  
  /*
!  * Returns whether a pg_class tuple belongs to a temp namespace which is not
!  * our backend's.
!  */
! static bool
! relid_is_other_temp(Oid class_oid)
! {
! 	HeapTuple	tuple;
! 	Form_pg_class classForm;
! 	bool		istemp;
! 
! 	tuple = SearchSysCache(RELOID,
! 						   ObjectIdGetDatum(class_oid),
! 						   0, 0, 0);
! 	if (!HeapTupleIsValid(tuple))
! 		ereport(ERROR,
! 				(errcode(ERRCODE_UNDEFINED_TABLE),
! 				 errmsg("relation with OID %u does not exist", class_oid)));
! 
! 	classForm = (Form_pg_class) GETSTRUCT(tuple);
! 	istemp = isOtherTempNamespace(classForm->relnamespace);
! 
! 	ReleaseSysCache(tuple);
! 
! 	return istemp;
! }
! 
! /*
!  * Get a list of tables that the current user owns, have indisclustered set,
!  * and are not temp tables of remote backends.  Return the list in a List * of
!  * rvsToCluster with the tableOid and the indexOid on which the table is
!  * already clustered.
   */
  static List *
  get_tables_to_cluster(MemoryContext cluster_context)
*************** get_tables_to_cluster(MemoryContext clus
*** 1031,1036 ****
--- 1064,1072 ----
  		if (!pg_class_ownercheck(index->indrelid, GetUserId()))
  			continue;
  
+ 		if (relid_is_other_temp(index->indrelid))
+ 			continue;
+ 
  		/*
  		 * We have to build the list in a different memory context so it will
  		 * survive the cross-transaction processing
Index: src/backend/commands/indexcmds.c
===================================================================
RCS file: /home/alvherre/Code/cvs/pgsql/src/backend/commands/indexcmds.c,v
retrieving revision 1.162
diff -c -p -r1.162 indexcmds.c
*** src/backend/commands/indexcmds.c	25 Aug 2007 19:08:19 -0000	1.162
--- src/backend/commands/indexcmds.c	25 Aug 2007 22:11:18 -0000
*************** ReindexDatabase(const char *databaseName
*** 1292,1297 ****
--- 1292,1301 ----
  		if (classtuple->relkind != RELKIND_RELATION)
  			continue;
  
+ 		/* Skip temp tables of other backends; we can't reindex them at all */
+ 		if (isOtherTempNamespace(classtuple->relnamespace))
+ 			continue;
+ 
  		/* Check user/system classification, and optionally skip */
  		if (IsSystemClass(classtuple))
  		{
